// C-Programm zur Bestimmung der Hufigkeit von Zeichen im Text txt
// Entwicklungsumgebung Dev-C++  Version 4.9.9.2, frei ladbare GNU-Software
// Nur fr Experimentierzwecke!
// Der Text txt kann durch beliebige andere Zeichenketten ersetzt werden
// 08.05.2007
// Textbeispiel: // Walter Moers, "Die 13 1/2 Leben des Kpt'n Blaubr", Mein Leben in den Finsterbergen
// Hinweis: Die Funktionen strstr und strcat vertragen beim verwendeten Compiler
// als zweite Parameter keine Einzel-Character (diese haben nicht die geforderte Endekennung mit '\0'). 
// Daher muss der zweite Parameter als String cha[2] mit cha[1] = '\0' deklariert sein, 
// sonst "hngt" sich das System beim Compilieren auf.
// Im Programm-Beispiel 2 mit mit den Doppel-Zeichen tritt das Problem nicht auf, 
// da diese ohnehin als String deklariert sind.


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void main (void)
{
  int ia,i,ih, iha, ihb, ie, j, ja,je, k,ka, ke, sum, ntxt, nchc, sum_zeichen[500], f_hilf[500];
  
  char ch, cha[2]={' ','\0'}, chc[500], chc_hilf[500], *txt;
  
  unsigned char l1u;
  
  txt="\"Wissen\", brllte Professor Nachtigaller in den Klassenraum und ri dabei seine Augen auf, bis sie so gro wie Untertassen waren, \"Wissen ist Nacht!\" Das war ein Lehrsatz der Eydeetischen Philophysik, ein Fach, das nur an der Nachtschule gelehrt wurde. Professor Nachtigaller sagte fter solche Sachen, wahrscheinlich um uns aus der Fassung zu bringen. Es steckte Methode in diesen scheinbar sinnlosen Behauptungen. Bevor man dahinterkam, dass sie vllig blde waren, hatte man in alle mglichen Richtungen gedacht. Und das war genau das, was Professor Nachtigaller wollte: Wir sollten denken lernen, und zwar in mglichst viele verschiedenen Richtungen. In diesem Fall steckte allerdings eine gewisse Wahrheit in dem, was er gesagt hatte, denn Professor Nachtigaller war ein Eydeet. Eydeete sind die intelligentesten Wesen Zamoniens (und vermutlich der ganzen Welt, wenn nicht sogar des Universums): Bei normaler Beleuchtung haben sie einen Intelligenzquotienten von 4000, aber wenn es dunkel wird, steigert er sich ins Unvorstellbare. Daher halten sich Eydeete geren in mglichst finsteren Verhltnissen auf, und deshalb war Nachtigallers Nachtakademie in einem dsteren Hhlensystem in den Finsterbergen untergebracht. Professor Nachtigaller arbeitete in seiner Freizeit an einem System, Dunkelheit noch dunkler zu machen. Er hatte sich dafr eigens eine Dunkelkammer eingerichtet, die niemand auer ihm betreten durfte. Wir legten auch keinen groen Wert darauf, denn die Gerusche. die wir hrten, wenn wir gelegentlich an der Tr horchten, waren alles andere als einladend. Ein normaler Eydeet hat drei Gehirne, ein begabter vier, ein Eydeet mit Geniestatus fnf, Professor Nachtigaller hatte sieben. Eins davon befand sich im Kopf, vier wuchsen ihm aus der Schdelplatte, eins sa da, wo normalerweise die Milz ist, und wo das siebte Gehirn war, blieb ewiger Gegenstand der Spekulation seiner Schler.";
  ntxt=strlen(txt);
  printf("\n%s\t\t\t%d\n","Anzahl der Zeichen im Text:",ntxt);
  
 //Liste der verschiedenen Zeichen, Ergebnis Zeichenkette chc
  strcpy(chc,"");
  for(i=0;i<ntxt;i++) 
   { 
   ch=txt[i];                                        
   cha[0]=ch;
   if (!strstr(chc,cha)) strcat(chc,cha);
    }
  nchc=strlen(chc);
  printf("\n%s\n\n","Alle verschiedenen Zeichen im Text:");
  // Ausgabe-Anpassung der Umlaute usw.:
  for (i=0;i<nchc;i++)
  {
      l1u= chc[i];
      if(l1u==228) l1u=132; //
      if(l1u==246) l1u=148; //
      if(l1u==252) l1u=129; //
      if(l1u==196) l1u=142; //
      if(l1u==214) l1u=153; //
      if(l1u==220) l1u=154; //
      if(l1u==223) l1u=225; //
      printf("%c", l1u);
  }
  printf("\n\n%s\t%d\n\n%s","Anzahl aller verschiedenen Zeichen im Text:",nchc,"Zur Ausgabe der unsortierten Zeichen: ");
  
  // Haltepunkt fr Bildschirmausgabe:
  system("Pause");
  
  //Zhlung der Hufigkeiten der Einzelzeichen:
            
  for (i=0;i<nchc;i++)
  {
  ch=chc[i];
  sum=0;
  for(j=0;j<ntxt;j++) if (ch==txt[j]) sum++;
  sum_zeichen[i]=sum;
  }
  //Ausgabe der Zeichen und ihre Hufigkeiten
  printf("\n%s\n","Unsortierte Liste der Hufigkeiten und Wahrscheinlichkeiten:");
  
  sum=0;
  for (i=0;i<nchc;i++)
  {
      l1u= chc[i];
      if(l1u==228) l1u=132; //
      if(l1u==246) l1u=148; //
      if(l1u==252) l1u=129; //
      if(l1u==196) l1u=142; //
      if(l1u==214) l1u=153; //
      if(l1u==220) l1u=154; //
      if(l1u==223) l1u=225; //
 
      printf("\n%d\t%c\t%d\t%2.6f",i,l1u,sum_zeichen[i], ((float) sum_zeichen[i]/(float) ntxt));
      sum=sum+sum_zeichen[i];
  }
  
  printf("\n\n%s","Zur Kontrollausgabe der Zeichenanzahlen: ");
  // Kontrollpunkt fr Bildschirmausgabe
  
  system("Pause");
  
  // Kontrollausgabe der Zeichenanzahl im Vergleich:
                     
  printf("\n\%s%d\%s%d\n","Anzahl der Textzeichen und Summe der Hufigkeiten: ",ntxt, " und ",sum);
  
  printf("\n\n%s","Zur Ausgabe der sortierten Einzel-Zeichen: ");
  system("Pause");
  
  // Ausgabe der sortierten Liste der Einzel-Zeichen mit Hufikeiten und Wahrscheinlichkeiten
   
   printf("\n\n%s\n","Sortierte Liste der Einzel-Zeichen nach fallenden Hufigkeiten:");
  // Zhlung Ende
  
  //Kopieren in Hilfsfelder:
  for (i=0;i<nchc;i++) chc_hilf[i]= chc[i];
  for (i=0;i<nchc;i++) f_hilf[i]= sum_zeichen[i];
  
  // Sortieren
  
  ia=0;
  while (ia < nchc)
  {
      iha=0;
      ih=f_hilf[ia];
      ch=chc_hilf[ia];
      for (j=ia+1;j<nchc;j++) if (ih<f_hilf[j])  iha=j;
      if (iha != 0)
      {
      for (k=ia;k<iha;k++) {f_hilf[k]=f_hilf[k+1]; chc_hilf[k]=chc_hilf[k+1];}
      f_hilf[iha]=ih;
      chc_hilf[iha]=ch;
      }  else ia=ia+1;
  
  }
  
  for (i=0;i<nchc;i++) 
  {
      l1u= chc_hilf[i];
      if(l1u==228) l1u=132; //
      if(l1u==246) l1u=148; //
      if(l1u==252) l1u=129; //
      if(l1u==196) l1u=142; //
      if(l1u==214) l1u=153; //
      if(l1u==220) l1u=154; //
      if(l1u==223) l1u=225; //
      printf("\n%d\t%c\t%d\t%2.6f",i,l1u,f_hilf[i],((float) f_hilf[i]/(float) ntxt));
    
  }
  
  // Das Ergebnis kann z. B. zum Aufbau eines Huffman-Binrbaumes dienen
   
   printf("\n\n%s", "Zum Beenden: "); 
      
  system("PAUSE");
}

